package vio.app;

import java.awt.*;
import java.awt.event.*;

import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;

import javax.media.j3d.*;
import javax.vecmath.*;

import vio.util.*;
import vio.tracker.TrackerManager;
import modin.util.*;

public class trackerJ3D extends Frame {

	public BranchGroup createSceneGraph() {

		BranchGroup objRoot = new BranchGroup();
		TransformGroup objTrans = new TransformGroup();
		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		objRoot.addChild(objTrans);
		objTrans.addChild(new ColorCube(0.2));
		Transform3D yAxis = new Transform3D();
		Alpha rotationAlpha = new Alpha(-1, Alpha.INCREASING_ENABLE,
						0, 0,
						4000, 0, 0,
						0, 0, 0);
		RotationInterpolator rotator =
		new RotationInterpolator(rotationAlpha, objTrans, yAxis,
					0.0f, (float) Math.PI*2.0f);

		BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
		rotator.setSchedulingBounds(bounds);
		objTrans.addChild(rotator);
		return objRoot;
	}


	public trackerJ3D() {

		fullScreenWindow fsw = new fullScreenWindow(this);
		TrackerManager tracker = new TrackerManager(false);
		boolean trackerAvailable = tracker.init();

		while (!trackerAvailable) {
			tracker = new TrackerManager(false);
			trackerAvailable=tracker.init();
			if (!trackerAvailable)
				System.out.println("please check the tracker ...");
		}

		//the trackerInputDevice
		j3dTrackerInputDevice device = new j3dTrackerInputDevice( tracker );

		// now create the trackerJava3D
		Canvas3D c = new Canvas3D(null);

		c.setLeftManualEyeInImagePlate(new Point3d(0.142f, 0.135f, 0.4572f));
		c.setRightManualEyeInImagePlate(new Point3d(0.208f, 0.135f, 0.4572f));
		c.setStereoEnable(true);
		c.setDoubleBufferEnable(true);

		fsw.add(c);
		fsw.Show(640,480);

		// Create a simple scene and attach it to the virtual universe
		BranchGroup scene = createSceneGraph();
		SimpleUniverse u = new SimpleUniverse(c);

		// The InputDevice must be initialized before registering it
		// with the PhysicalEnvironment object.
		device.initialize();

		// Register the VirtualInputDevice with Java 3D
		u.getViewer().getPhysicalEnvironment().addInputDevice( device );

		TransformGroup viewTrans =  u.getViewingPlatform().getViewPlatformTransform();
		SensorBehavior s = new SensorBehavior( viewTrans, device.getSensor(0) );
		s.setSchedulingBounds( new BoundingSphere ( new Point3d(0.0,0.0,0.0), Float.MAX_VALUE ));
		scene.addChild( s );
		u.addBranchGraph(scene);
	}


	public static void main(String[] args) {
		new trackerJ3D();
	}
}
