package vio.app;

import javax.comm.*;
import vio.tracker.*;

public class trackerTest {

	public static void main (String argv[]) {

		TrackerManager tracker = null;

		TrackerData myTrackerData   = new TrackerData();
		TrackerData lastTrackerData = new TrackerData();
		TrackerData zeroTrackerData = new TrackerData();
		TrackerInfo myTrackerInfo   = null;
		
		float yaw   = 0.0f;
		float pitch = 0.0f;
		float roll  = 0.0f;		

		boolean trackerAvailable = false;
		String trackerPortName   = "";
		
		long startTime = 0;
		long frames    = 0;
		short fps      = 0;
		
		// wrong arguments	
		if (argv.length > 1) {
			System.out.println("usage: java trackerTest [SerialPortName]");
			System.exit(0);
		}
		// if started with a portname	
		else if (argv.length == 1) {
			tracker = new TrackerManager(argv[0], true);
			trackerAvailable=tracker.init();
			
			while (!trackerAvailable) {
				System.out.println("please check the tracker ...");
				tracker = new TrackerManager(argv[0],true);
				trackerAvailable=tracker.init();
			}
		}
		// if started without portname, looking for a tracker
		else if (argv.length == 0) {
			tracker = new TrackerManager(true);
			trackerAvailable = tracker.init();
			
			while (!trackerAvailable) {
				System.out.println("please check the tracker ...");
				tracker = new TrackerManager(true);
				trackerAvailable=tracker.init();
			}
		}
					
		// getting the name of the SerialPort the tracker is connected to
		trackerPortName = tracker.getTrackerPortName();
		
		// getting the TrackerInfo
		try { 
			myTrackerInfo = tracker.getTrackerInfo();
			myTrackerInfo.printInfo();
		}
		catch (NullPointerException e) { System.out.println("failed getting TrackerInfo"); }
		
		//tracker.start();	
		startTime=System.currentTimeMillis();
	
		while (true) {
			try {
				myTrackerData = tracker.getTrackerData();
				yaw   = myTrackerData.yawAngle;
				pitch = myTrackerData.pitchAngle;
				roll  = myTrackerData.rollAngle;
			} catch (TrackerManagerException tme) {
				//tracker.stop();
				tracker.close();
				tracker = null;
				trackerAvailable = false;
				while (!trackerAvailable) {
					System.out.println("please check the tracker ...");
					tracker = new TrackerManager(trackerPortName,true);
					trackerAvailable = tracker.init();
				}
		
				//tracker.start();	
				startTime = System.currentTimeMillis();
				frames=0;
			}

			fps = (short)(frames/((System.currentTimeMillis()-startTime)/1000+1));
			 
			if ( (!myTrackerData.equals(lastTrackerData)) && (!myTrackerData.equals(zeroTrackerData)) ){
				System.out.println("y:"+yaw+"\tp:"+pitch+"\tr:"+roll+"\tfps:"+fps);
				frames ++;
			}
	
			lastTrackerData = myTrackerData;
			   
			// waiting a while
			try { Thread.sleep(10); }
			catch (InterruptedException e) {}		
		}
	}

}
