package vio.util;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import vio.tracker.*;
import modin.util.*;

public class panoCanvas extends Canvas implements Runnable {
	//the driver and the data object
	TrackerManager tracker;
	TrackerData myTrackerData, lastTrackerData, zeroTrackerData;

	//the displayed image
	Image svrImage;

	Image offScreenImage;
	Graphics offScreenG;
	
	//some variables
	float panAngle = 0;
	int screenPosition = 0;
	int width;
	float step;

	//the main thread
	Thread myThread = null;
	fullScreenWindow fsw;
	
	public panoCanvas(Image svrImage, fullScreenWindow fsw, TrackerManager tracker) {
	
		this.svrImage = svrImage;
		this.tracker = tracker;
		this.fsw = fsw;
		
		fsw.add(this);
		setSize(640,480);

		width = svrImage.getWidth(this);
		step  = (float)-width/360f;
		
		myTrackerData = new TrackerData();
		lastTrackerData = new TrackerData();
		zeroTrackerData = new TrackerData();
		
		addMouseListener (
			new MouseAdapter () {
        			public void mouseClicked (MouseEvent evt) {
					killAll();
      				}
			}
    		);

	}

	private void killAll() {
		stop();

		try { fsw.remove(this); fsw.Hide(); fsw=null; }
		catch (Exception e) {}
		
		try { tracker.close(); tracker=null; }
  		catch (Exception e) {}	
 	}
	
	
	public void paint(Graphics g)
	{	
		update(g);
	}
	
	public void update(Graphics g)
	{
		if (offScreenImage!=null)	
			g.drawImage(offScreenImage,0,0,this);
	}

	public void start()
	{
		if (myThread == null)
		{
			offScreenImage = createImage(640,480);
			offScreenG = offScreenImage.getGraphics();
			offScreenG.drawImage(svrImage,0,0,this);
			
			myThread = new Thread( this );
			myThread.start();
		}

	}

	public void stop()
	{
		if (myThread != null)
		{
			myThread.stop();
			myThread = null;
		}
	}

	// the main loop
	// receives the yawAngle from the tracker
	// and calculates the actual screenPosition for the panorama
	public void run()
	{	
		String trackerPortName = tracker.getTrackerPortName();
	
		while (true) {
			try {
				myTrackerData = tracker.getTrackerData();
				
				panAngle= -(myTrackerData.yawAngle);
				if (panAngle<0) panAngle += 360;

				screenPosition = (int)Math.round(step*panAngle);
			}
			//if the tracker has been turned off
			catch (TrackerManagerException tme) {
				tracker.close();
				tracker = null;
				boolean trackerAvailable=false;
				while (!trackerAvailable) {
					tracker = new TrackerManager(trackerPortName,false);
					trackerAvailable = tracker.init();

					if (!trackerAvailable)
						System.out.println("please check the tracker ...");
					/*try { Thread.sleep(100); }
            				catch (InterruptedException e) {}*/
				}
			}
	
			if (!myTrackerData.equals(lastTrackerData)) 
			{
				// draws the image to the actual position
				offScreenG.drawImage(svrImage,screenPosition,0,this);
	
				// closes the panorama
				if (screenPosition<(-width+640))
					offScreenG.drawImage(svrImage,width+screenPosition,0,this);
				
				repaint();
			}
		
			lastTrackerData = myTrackerData;
			
			// for a framerate of about 20 fps
			try { Thread.sleep(40); }
			catch (InterruptedException e) {};	
		}
	}

}
